//---------------------------------------------------------------------------

#include <vcl.h>
#include <iostream>
#include <iterator>
#include <set>
#include <conio.h> //  getch()

#pragma hdrstop

//---------------------------------------------------------------------------

#pragma argsused
using namespace std;

std::string ToRus(const std::string &in)
{
  char *buff = new char [in.length()+1];
  CharToOem(in.c_str(),buff);
  std::string out(buff);
  delete [] buff;
  return out;
}

int main(int argc, char* argv[])
{
  //  :
  //-  
  //-   int
  //-   

  typedef set<int,greater<int> > IntSet;
  IntSet coll1; //  

  //     
  coll1.insert(4);
  coll1.insert(3);
  coll1.insert(5);
  coll1.insert(1);
  coll1.insert(6);
  coll1.insert(2);
  coll1.insert(5);

  //      
  IntSet::iterator pos;
  cout << ToRus(" :\n");
  for (pos = coll1.begin();pos != coll1.end(); ++pos) { 
    cout << *pos << ' ';
  }
  cout << endl;

  //     4 
  //     
  pair<IntSet::iterator,bool> status = coll1.insert(4); 
  if (status.second) {
    cout << "4 inserted as element "
         << distance(coll1.begin(),status.first) + 1 
         << endl;
  } 
  else {
      cout << ToRus(" 4  ") << endl;
  }

  //    , 
  //    
  set<int> coll2(coll1.begin(),coll1.end());

  //     
  cout << ToRus("  :\n");
  copy (coll2.begin(), coll2.end(),
        ostream_iterator<int>(cout," ")); 
  cout << endl;

  //        3 
  coll2.erase(coll2.begin(),coll2.find(3));

  //      5
  int num;
  num = coll2.erase(5);
  cout << num << ToRus(" () ()") << endl;

  //   
  cout << ToRus("   :\n");
  copy (coll2.begin(),coll2.end(),
        ostream_iterator<int>(cout," ")); 
  cout << endl;


  getch();
  return 0;
}
//---------------------------------------------------------------------------
